﻿@page "/hotel/create"

<h3>Create Hotel</h3>

<NextHotelForm Model="Form"
               OnValidSubmit="OnValidSubmit"
               SuccessMessage="SuccessMessage"
               Disabled="IsLoading">
    <FormComponent>
        <div class="form-group row">
            <label class="col-2 col-form-label" for="Photo">Photo</label>
            <div class="col-10">
                <InputFile OnChange="@LoadFiles" multiple />

                @{
                    if (string.IsNullOrEmpty(UploadStatus.UploadMessage) == false)
                    {
                        var alertClass = "alert-success";

                        if (UploadStatus.IsSuccessUpload == false)
                        {
                            alertClass = "alert-danger";
                        }

                        <div class="alert @alertClass mt-2">
                            @UploadStatus.UploadMessage
                        </div>
                    }
                }

                <ValidationMessage For="() => Form.Photo"></ValidationMessage>
            </div>
        </div>
        <div class="form-group row">
            <label class="col-2 col-form-label" for="country">Country</label>
            <div class="col-10">
                @* @bind-Value is composed by these following parameters:
                    - Value
                    - ValueExpression
                    - ValueChanged
                    Inside ValueChanged, basically it will assign the binded object value with the new one.
                    For example, if you @bind-Value="CountryId", ValueChanged will invoke these codes:
                    OnValueChanged(int newSelectedCountryId)
                    {
                        CountryId = newSelectedCountryId;
                    }
                *@
                <InputSelect Value="CountryId"
                             ValueExpression="() => CountryId"
                             ValueChanged="(int newSelectedCountryId) => OnCountryChange(newSelectedCountryId)"
                             id="country"
                             class="form-control">
                    <option value="0" hidden></option>
                    @foreach (var countryOption in CountryOptions)
                    {
                        <option value="@countryOption.Value">@countryOption.Label</option>
                    }
                </InputSelect>
            </div>
        </div>

        <div class="form-group row">
            <label class="col-2 col-form-label" for="state">State</label>
            <div class="col-10">
                <InputSelect Value="StateId"
                             ValueExpression="() => StateId"
                             ValueChanged="(int newSelectedStateId) => OnStateChange(newSelectedStateId)"
                             id="state"
                             class="form-control">
                    <option value="0" hidden></option>
                    @foreach (var stateOption in StateOptions)
                    {
                        <option value="@stateOption.Value">@stateOption.Label</option>
                    }
                </InputSelect>
            </div>
        </div>

        <div class="form-group row">
            <label class="col-2 col-form-label" for="city">City</label>
            <div class="col-10">
                <InputSelect @bind-Value="Form.CityId"
                             id="city"
                             class="form-control">
                    <option value="0" hidden></option>
                    @foreach (var cityOption in CityOptions)
                    {
                        <option value="@cityOption.Value">@cityOption.Label</option>
                    }
                </InputSelect>
                <ValidationMessage For="() => Form.CityId"></ValidationMessage>
            </div>
        </div>

        <div class="form-group row">
            <label class="col-2 col-form-label" for="name">Name</label>
            <div class="col-10">
                <InputText id="name" type="text" class="form-control" @bind-Value="Form.HotelName"></InputText>
                <ValidationMessage For="() => Form.HotelName"></ValidationMessage>
            </div>
        </div>

        <div class="form-group row">
            <label class="col-2 col-form-label" for="address">Address</label>
            <div class="col-10">
                <InputTextArea @bind-Value="Form.Address"
                               id="address"
                               class="form-control"></InputTextArea>
                <ValidationMessage For="() => Form.Address"></ValidationMessage>
            </div>
        </div>

        <div class="form-group row">
            <label class="col-2 col-form-label" for="rating">Rating</label>
            <div class="col-10">
                <StarRatingInput @bind-Value="Form.StarRating"></StarRatingInput>
            </div>
        </div>
    </FormComponent>
</NextHotelForm>